# include <stdio.h>
# include <stdlib.h>
# include <math.h>

# include "global.h"
# include "rand.h"

void score_pop (population *pop_final)
{
	//SP
	int h, g, m;
	int num_criterion = 500;

	double d_avg, sp, d, sum=0, sum2, ms;
	double *min, *min_ms, *max_ms;
	
	FILE *sp_ptr;	
	FILE *ms_ptr;
	FILE *new_ms_ptr;

	min = (double *) malloc (popsize * sizeof(double));
	min_ms = (double *) malloc (nobj * sizeof(double));
	max_ms = (double *) malloc (nobj * sizeof(double));

	sp_ptr = fopen ("sp.txt", "a");
	ms_ptr = fopen ("ms.txt", "a");
	new_ms_ptr = fopen ("new_ms.txt", "a");

	for (m = 0; m < nobj; m++)
	{
		min_ms[m] = INF;
		max_ms[m] = -100000;
	}
    
	for (h = 0; h < popsize; h++)
	{
		for (m = 0; m < nobj; m++)
		{
			if (pop_final->ind[h].obj[m] < min_ms[m])
			{
				min_ms[m] = pop_final->ind[h].obj[m];
			}
			if (pop_final->ind[h].obj[m] > max_ms[m])
			{
				max_ms[m] = pop_final->ind[h].obj[m];
			}
		}
	}
	sum2 = 0;
	for (m = 0; m < nobj; m++)
	{
		sum2 += pow (max_ms[m] - min_ms[m], 2);
	}
	ms = sqrt (sum2);
	fprintf (ms_ptr, "%f\n", ms);
	
	for (m = 0; m < nobj; m++)
	{
		if (max_ms[m] > max_pf[m])
		{
			max_ms[m] = max_pf[m];
		}
		if (min_ms[m] < min_pf[m])
		{
			min_ms[m] = min_pf[m];
		}
	}

	sum2 = 0;
    for (m = 0; m < nobj; m++)
	{
		sum2 += pow ((max_ms[m] - min_ms[m]) / (max_pf[m] - min_pf[m]), 2.0);
	}
	ms = sqrt (sum2 / nobj);
    fprintf (new_ms_ptr, "%f\n", ms);

	for (h = 0; h < popsize; h++)
	{  	
		min[h] = INF;
		for (g = 0; g < popsize; g++)
		 if (h != g)
		 {
            d = 0;
			for (m = 0; m < nobj; m++)
			{
			  d += (pop_final->ind[h].obj[m] - pop_final->ind[g].obj[m] > 0 ? pop_final->ind[h].obj[m] - pop_final->ind[g].obj[m] : pop_final->ind[g].obj[m] - pop_final->ind[h].obj[m]);
			}
         // min[h]+=d ;

			if (d < min[h])
			{
				min[h] = d;
			}
		 }
		//min[h]=min[h]/popsize;
		sum += min[h];
	}
	d_avg = sum / popsize;
	sp = 0; 
	for (h = 0; h < popsize; h++)
	{
		sp += (d_avg - min[h]) * (d_avg - min[h]);
	}
    sp = sqrt (sp / (popsize - 1));
    fprintf (sp_ptr, "%f\n", sp);

	fclose (sp_ptr);
	fclose (ms_ptr);
	fclose (new_ms_ptr);

	free (min);
	free (min_ms);
	free (max_ms);
}