/* Routine for evaluating population members  */

# include <stdio.h>
# include <stdlib.h>
# include <math.h>

# include "global.h"
# include "rand.h"

__declspec(dllimport) void test_problem_wfg (double *xreal,double *obj, int nreal, int nobj, int k, char *type);

/* Routine to evaluate objective function values and constraints for a population */
void evaluate_pop (population *pop, int size)
{
    int i;

    for (i = 0; i < size; i++)
    {
        evaluate_ind (&(pop->ind[i]));
    }

    return;
}

/* Routine to evaluate objective function values and constraints for an individual */
void evaluate_ind (individual *ind)
{
    test_problem (ind->xreal, ind->obj);
	//test_problem_wfg (ind->xreal,ind->obj,nreal, nobj, k, "wfg4");
}
