/* Data initializtion routines */

# include <stdio.h>
# include <stdlib.h>
# include <math.h>

# include "global.h"
# include "rand.h"

/* Function to initialize a population randomly */
void initialize_pop (population *pop)
{
    int i;

    for (i = 0; i < popsize; i++)
    {
        initialize_ind (&(pop->ind[i]));
    }
    return;
}

/* Function to initialize an individual randomly */
void initialize_ind (individual *ind)
{
    int i;

    if (nreal != 0)
    {
        for (i = 0; i < nreal; i++)
        {
            ind->xreal[i] = rndreal (min_realvar[i], max_realvar[i]);
        }
    }
    return;
}